diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index b0262b031..652a073fa 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -1,630 +1,712 @@
 package net.minecraft.client.option;
 
-import static net.minecraft.core.util.Util.emptyStringIfNull;
-import static org.lwjgl.input.Keyboard.*;
-
-import java.io.BufferedReader;
-import java.io.File;
-import java.io.FileReader;
-import java.io.FileWriter;
-import java.io.PrintWriter;
-import java.util.ArrayList;
-import java.util.List;
-
 import com.mojang.logging.LogUtils;
-
+import it.unimi.dsi.fastutil.objects.Object2ObjectOpenHashMap;
+import it.unimi.dsi.fastutil.objects.ObjectArrayList;
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.ScaledResolution;
 import net.minecraft.client.discord.RichPresenceHandlerThread;
 import net.minecraft.client.enums.MusicFrequency;
 import net.minecraft.client.gui.TooltipElement;
 import net.minecraft.client.gui.hud.component.HudComponents;
 import net.minecraft.client.gui.options.ScreenOptions;
 import net.minecraft.client.input.InputDevice;
+import net.minecraft.client.option.enums.CloudQuality;
 import net.minecraft.client.option.enums.Colorblindness;
-import net.minecraft.client.render.font.Fonts;
 import net.minecraft.client.option.enums.DescriptionPromptEnum;
+import net.minecraft.client.option.enums.LeavesQuality;
+import net.minecraft.client.option.enums.LightmapStyle;
+import net.minecraft.client.option.enums.MipmapType;
+import net.minecraft.client.option.enums.ParticlesQuality;
+import net.minecraft.client.option.enums.RenderScale;
+import net.minecraft.client.option.enums.TextOutlineQuality;
+import net.minecraft.client.option.enums.TextureAnimation;
+import net.minecraft.client.render.font.Fonts;
 import net.minecraft.client.world.chunk.provider.SelectedProvider;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.ChatVisibility;
 import net.minecraft.core.enums.Difficulty;
-import net.minecraft.client.option.enums.LightmapStyle;
-import net.minecraft.client.option.enums.MipmapType;
-import net.minecraft.client.option.enums.RenderScale;
 import net.minecraft.core.enums.PlacementMode;
-import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Color;
-import net.minecraft.core.util.helper.ITranslatable;
-
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.lwjgl.input.Keyboard;
 import org.slf4j.Logger;
 
-public class GameSettings {
-	private static final Logger LOGGER = LogUtils.getLogger();
-	private static final String[] ANIMATIONS = { "options.animations.off", "options.animations.procedural", "options.animations.custom" };
-
-	public final Minecraft mc;
-	private final File optionsFile;
-
-	public @NotNull OptionInteger windowWidth = new OptionInteger(this, "windowWidth", 854);
-	public @NotNull OptionInteger windowHeight = new OptionInteger(this, "windowHeight", 480);
-	
-	public @NotNull OptionVolume masterVolume = new OptionVolume(this, "sound.master", 1.0f, SoundCategory.GUI_SOUNDS);
-	public @NotNull OptionVolume musicVolume = new OptionVolume(this, "sound.music", 1.0f, SoundCategory.MUSIC);
-	public @NotNull OptionVolume worldSoundsVolume = new OptionVolume(this, "sound.world", 1.0f, SoundCategory.WORLD_SOUNDS);
-	public @NotNull OptionVolume entitySoundsVolume = new OptionVolume(this, "sound.entity", 1.0f, SoundCategory.ENTITY_SOUNDS);
-	public @NotNull OptionVolume caveSoundsVolume = new OptionVolume(this, "sound.cave", 1.0f, SoundCategory.CAVE_SOUNDS);
-	public @NotNull OptionVolume guiSoundsVolume = new OptionVolume(this, "sound.gui", 1.0f, SoundCategory.GUI_SOUNDS);
-	public @NotNull OptionVolume weatherSoundsVolume = new OptionVolume(this, "sound.weather", 1.0f, SoundCategory.WEATHER_SOUNDS);
-	public @NotNull OptionBoolean playTitleScreenMusic = new OptionBoolean(this, "playTitleScreenMusic", false);
-	
-	public @NotNull OptionFloat FoV = new OptionFloat(this, "fov", 0.40140846f);
-	public @NotNull OptionFloat mouseSensitivity = new OptionFloat(this, "mouseSensitivity", 0.5f);
-	public @NotNull OptionFloat screenPadding = new OptionFloat(this, "screenPadding", 0.0f);
-	public @NotNull OptionFloat gamma = new OptionFloat(this, "gamma", 0.5f);
-	public @NotNull OptionFloat brightness = new OptionFloat(this, "brightness", 0.5f);
-
-	public @NotNull OptionFloat fxaa = new OptionFloat(this, "fxaa", 0.0f);
-	public @NotNull OptionFloat controllerSensitivity = new OptionFloat(this, "controllerSensitivity", 0.5f);
-	public @NotNull OptionFloat controllerMenuSensitivity = new OptionFloat(this, "controllerMenuSensitivity", 0.5f);
-	public @NotNull OptionFloat controllerDeadzoneLeft = new OptionFloat(this, "controllerDeadzoneL", 0.25f);
-	public @NotNull OptionFloat controllerDeadzoneRight = new OptionFloat(this, "controllerDeadzoneR", 0.25f);
-	public @NotNull OptionFloat blockOutlineWidth = new OptionFloat(this, "blockOutlineWidth", 0.25f);
-	
-	public @NotNull OptionFloat flightSpeed = new OptionFloat(this, "flightSpeed", 0.5f);
-	public @NotNull OptionFloat flightSmoothness = new OptionFloat(this, "flightSmoothness", 0.5f);
-
-	public @NotNull OptionBoolean invertMouse = new OptionBoolean(this, "invertYMouse", false);
-	public @NotNull OptionBoolean rawMouseInput = new OptionBoolean(this, "rawMouseInput", false);
-	public @NotNull OptionBoolean viewBobbing = new OptionBoolean(this, "bobView", true);
-//	public @NotNull OptionBoolean advancedOpenGL = new OptionBoolean(this, "advancedOpengl", false);
-	public @NotNull OptionRange fancyGraphics = new OptionRange(this, "fancyGraphics", 1, 2);
-	public @NotNull OptionBoolean treeShadows = new OptionBoolean(this, "treeShadows", true);
-	public @NotNull OptionBoolean connectedGlass = new OptionBoolean(this, "connectedGlass", false);
-	public @NotNull OptionBoolean ambientOcclusion = new OptionBoolean(this, "ambientOcclusion", true);
-	public @NotNull OptionBoolean items3D = new OptionBoolean(this, "3Ditems", false);
-	public @NotNull OptionBoolean smoothCamera = new OptionBoolean(this, "smoothCamera", false);
-	public @NotNull OptionBoolean lockCamera = new OptionBoolean(this, "lockCamera", false);
-	public @NotNull OptionBoolean biomeWater = new OptionBoolean(this, "biomeWater", true);
-	public @NotNull OptionBoolean vignette = new OptionBoolean(this, "vignette", true);
-	public @NotNull OptionBoolean showPlayerList = new OptionBoolean(this, "showPlayerList", false);
-	public @NotNull OptionBoolean slimeParticles = new OptionBoolean(this, "slimeParticles", true);
-//	public @NotNull OptionBoolean disableShaders = new OptionBoolean(this, "disableShaders", false);
-	public @NotNull OptionString shaderOverride = new OptionString(this, "shaderOverride", "");
-	public @NotNull OptionBoolean autoHit = new OptionBoolean(this, "autoHit", true);
-	public @NotNull OptionBoolean easyBridge = new OptionBoolean(this, "easyBridge", true);
-	public @NotNull OptionBoolean foodHealthRegenOverlay = new OptionBoolean(this, "foodHealthRegenOverlay", true);
-	public @NotNull OptionBoolean fpsInOverlay = new OptionBoolean(this, "fpsInOverlay", false);
-	public @NotNull OptionBoolean versionInOverlay = new OptionBoolean(this, "versionInOverlay", false);
-	public @NotNull OptionBoolean controllerSwapShoulderButtons = new OptionBoolean(this, "controllerSwapShoulderButtons", false);
-	public @NotNull OptionBoolean controllerSwapAB = new OptionBoolean(this, "controllerSwapAB", false);
-	public @NotNull OptionBoolean controllerSwapXY = new OptionBoolean(this, "controllerSwapXY", false);
-	public @NotNull OptionBoolean clouds = new OptionBoolean(this, "clouds", true);
-	public @NotNull OptionFloat cloudHeight = new OptionFloat(this, "cloudHeight", 0f);
-	public @NotNull OptionFloat entityRenderDistance = new OptionFloat(this, "entityRenderDistance", 1f);
-	public @NotNull OptionBoolean armorDurabilityOverlay = new OptionBoolean(this, "armorDurabilityOverlay", false);
-	public @NotNull OptionBoolean armorProtectionOverlay = new OptionBoolean(this, "armorProtectionOverlay", true);
-	public @NotNull OptionBoolean heldItemCountOverlay = new OptionBoolean(this, "heldItemCountOverlay", false);
-	public @NotNull OptionBoolean pauseOnLostFocus = new OptionBoolean(this, "pauseOnLostFocus", true);
-	public @NotNull OptionBoolean showDebugScreen = new OptionBoolean(this, "showDebugScreen", false);
-	public @NotNull OptionBoolean showFrameTimes = new OptionBoolean(this, "showFrameTimes", false);
-	public @NotNull OptionBoolean showItemDebugInfo = new OptionBoolean(this, "showItemDebugInfo", false);
-	public @NotNull OptionBoolean showChunkBorders = new OptionBoolean(this, "showChunkBorders", false);
-	public @NotNull OptionBoolean showCollisionBoxes = new OptionBoolean(this, "showCollisionBoxes", false);
-	public @NotNull OptionBoolean swapCraftingButtons = new OptionBoolean(this, "swapCraftingButtons", false);
-	public @NotNull OptionBoolean forceOnscreenKeyboard = new OptionBoolean(this, "forceOnscreenKeyboard", false);
-	public @NotNull OptionEnum<PlacementMode> placementMode = new OptionEnum<>(this, "placementMode", PlacementMode.class, PlacementMode.DEFAULT).setIsSlider(false);
-	public @NotNull OptionBoolean discordRichPresence = new OptionBoolean(this, "discordRichPresence", false);
-	public @NotNull OptionImmersiveMode immersiveMode = new OptionImmersiveMode(this);
-	public @NotNull OptionColor guiBackgroundColor = new OptionColor(this, "guiBackgroundColor", new Color().setARGB(0xc0101010));
-	public @NotNull OptionEnum<Difficulty> difficulty = new OptionEnum<>(this, "difficulty", Difficulty.class, Difficulty.NORMAL); // Stub for local difficulty setting
-	public @NotNull OptionInteger thirdPersonView = new OptionInteger(this, "thirdPersonView", 0);
-	public @NotNull OptionRange renderDistance = new OptionRange(this, "renderDistance", 12, 2, 32);
-	public @NotNull OptionBoolean enableVsync = new OptionBoolean(this, "enableVsync", false);
-	public @NotNull OptionEnum<ChatVisibility> chatVisibility = new OptionEnum<>(this, "chatVisibility", ChatVisibility.class, ChatVisibility.SHOW_ALL);
-	public @NotNull OptionRange customFpsLimit = new OptionRange(this,"customFpsLimit",165,301);
-	public @NotNull OptionInteger guiScale = new OptionInteger(this, "guiScale", 0);
-	public @NotNull OptionInteger overlayMode = new OptionInteger(this, "overlayMode", 0);
-	public @NotNull OptionInteger rotationOverlayMode = new OptionInteger(this, "rotationOverlayMode", 0);
-	public @NotNull OptionRange animations = new OptionRange(this, "animations", 2, 3);
-	public @NotNull OptionBoolean customAnimations = new OptionBoolean(this, "customAnimations", true);
-	public @NotNull OptionInteger playerListPosition = new OptionInteger(this, "playerListPosition", 2);
-	public @NotNull OptionBoolean heldItemTooltips = new OptionBoolean(this, "heldItemTooltips", true);
-	public @NotNull OptionFloat colorCorrection = new OptionFloat(this, "colorCorrection", 0.5f);
-	public @NotNull OptionBoolean sneakToggle = new OptionBoolean(this, "sneakToggle", false);
-	public @NotNull OptionFloat autosaveTimer = new OptionFloat(this, "autosaveTimer", 0.04166666666F);
-	public @NotNull OptionBoolean enableItemDragging = new OptionBoolean(this, "enableItemDragging", true);
-	public @NotNull OptionRange bloom = new OptionRange(this, "bloom", 0, 3);
-	public @NotNull OptionEnum<RenderScale> renderScale = new OptionEnum<>(this, "renderScale", RenderScale.class, RenderScale.SCALE_100);
-	public @NotNull OptionBoolean heatHaze = new OptionBoolean(this, "heatHaze", false);
-	public @NotNull OptionBoolean alphaMenu = new OptionBoolean(this, "old", false);
-	public @NotNull OptionBoolean enableItemClumping = new OptionBoolean(this, "enableItemClumping", true);
-	public @NotNull OptionEnum<DescriptionPromptEnum> itemDescriptions = new OptionEnum<>(this, "itemDescriptions", DescriptionPromptEnum.class, DescriptionPromptEnum.PROMPT);
-	public @NotNull OptionBoolean turnWithVehicle = new OptionBoolean(this, "turnWithVehicle", true);
-	public @NotNull OptionBoolean disableCrashHandler = new OptionBoolean(this, "disableCrashHandler", false);
-//	public @NotNull OptionBoolean enableMultiDrawRendering = new OptionBoolean(this, "enableMultiDrawRendering", true);
-	public @NotNull OptionEnum<SelectedProvider> enableThreadedChunkProvider = new OptionEnum<>(this, "enableThreadedChunkProvider", SelectedProvider.class, SelectedProvider.THREADED);
-	public @NotNull OptionBoolean musicToasts = new OptionBoolean(this, "musicToasts", true);
-	public @NotNull OptionEnum<MusicFrequency> musicFrequency = new OptionEnum<>(this, "musicFrequency", MusicFrequency.class, MusicFrequency.DEFAULT);
-
-	public @NotNull OptionBoolean enableDevResourceLoading = new OptionBoolean(this, "enableDevResourceLoading", false);
-	public @NotNull OptionBoolean downloadSoundfiles = new OptionBoolean(this, "downloadSoundfiles", true);
-	public @NotNull OptionBoolean allowSoundOverrides = new OptionBoolean(this, "allowSoundOverrides", false);
-	public @NotNull OptionBoolean loadAllSounds = new OptionBoolean(this, "loadAllSounds", false);
-	
-	public @NotNull OptionBoolean overlayShowCoords = new OptionBoolean(this, "overlayShowCoords", true);
-	public @NotNull OptionBoolean overlayShowDirection = new OptionBoolean(this, "overlayShowDirection", true);
-	public @NotNull OptionBoolean overlayShowTime = new OptionBoolean(this, "overlayShowTime", true);
-	public @NotNull OptionBoolean overlayShowSeason = new OptionBoolean(this, "overlayShowSeason", true);
-	public @NotNull OptionBoolean overlayShowWeather = new OptionBoolean(this, "overlayShowWeather", true);
-	public @NotNull OptionBoolean overlayShowBiome = new OptionBoolean(this, "overlayShowBiome", true);
-	
-	public @NotNull OptionBoolean @NotNull [] overlayElements = new OptionBoolean[] { overlayShowCoords, overlayShowDirection, overlayShowTime, overlayShowSeason, overlayShowWeather, overlayShowBiome };
-	
-	public @NotNull OptionString lastServer = new OptionString(this, "lastServer", "");
-	public @NotNull OptionString skin = new OptionString(this, "skin", "Default");
-	public @NotNull OptionString selectedController = new OptionString(this, "selectedController", "");
-    public @NotNull OptionString language = new OptionString(this, "language", "en_US");
-	
-	public @NotNull OptionRange mipmapLevels = new OptionRange(this, "mipmapLevels", 0, 5);
-	public @NotNull OptionEnum<MipmapType> mipmapType = new OptionEnum<>(this, "mipmapType", MipmapType.class, MipmapType.SMOOTH);
-
-	public @NotNull OptionBoolean fovModification = new OptionBoolean(this, "fov.modification", true);
-	public @NotNull OptionBoolean screenMotionEffects = new OptionBoolean(this, "screen.motion.effects", true);
-
-	public @NotNull OptionBoolean fullscreen = new OptionBoolean(this, "fullscreen", Minecraft.isClientASteamDeck());
-	public @NotNull OptionBoolean borderlessFullscreen = new OptionBoolean(this, "borderlessFullscreen", true);
-	public @NotNull OptionBoolean startInFullscreen = new OptionBoolean(this, "startInFullscreen", true);
-	public @NotNull OptionTooltip tooltipStyle = new OptionTooltip(this, "tooltipStyle", "default");
-	public @NotNull OptionFont font = new OptionFont(this, "font", Fonts.DEFAULT);
-	public @NotNull OptionEnum<LightmapStyle> lightmapStyle = new OptionEnum<>(this, "lightmapStyle", LightmapStyle.class, LightmapStyle.GRAY);
-	public @NotNull OptionBoolean customLightmap = new OptionBoolean(this, "customLightmap", true);
-	public @NotNull OptionBoolean fog = new OptionBoolean(this, "fog", true);
-	public @NotNull OptionBoolean hideUndiscoveredItems = new OptionBoolean(this, "hideUndiscoveredItems", true);
-	public @NotNull OptionBoolean muteOnLostFocus = new OptionBoolean(this, "muteOnLostFocus", false);
-	public @NotNull OptionBoolean aurora = new OptionBoolean(this, "aurora", true);
-	public @NotNull OptionBoolean mobVariants = new OptionBoolean(this, "mobVariants", true);
-	public @NotNull OptionEnum<Colorblindness> colorblindnessFix = new OptionEnum<>(this, "colorblindnessFix", Colorblindness.class, Colorblindness.NONE);
-	public @NotNull OptionBoolean subtitles = new OptionBoolean(this, "subtitles", false);
-	public @NotNull OptionBoolean developerMode = new OptionBoolean(this, "developerMode", false);
-	public @NotNull OptionBoolean viewSupportMode = new OptionBoolean(this, "viewSupportMode", false);
-	public @NotNull OptionBoolean enableHolidayTextures = new OptionBoolean(this, "enableHolidayTextures", true);
-	public @NotNull OptionBoolean dynamicCursor = new OptionBoolean(this, "dynamicCursor", true);
-	public @NotNull OptionBoolean devModels = new OptionBoolean(this, "devModels", true);
-	public @NotNull OptionBoolean doJCECheck = new OptionBoolean(this, "doJCECheck", true);
-	public @NotNull OptionString uuidServer = new OptionString(this, "uuidServer", "https://api.minecraftservices.com/minecraft/profile/lookup/name/%s");
-
-	public @NotNull OptionBoolean playerLeftHanded = new OptionBoolean(this, "player.left.handed", false);
-	public @NotNull OptionBoolean playerCape = new OptionBoolean(this, "player.cape", true);
-	public @NotNull OptionBoolean playerHat = new OptionBoolean(this, "player.hat", true);
-	public @NotNull OptionBoolean playerJacket = new OptionBoolean(this, "player.jacket", true);
-	public @NotNull OptionBoolean playerSleeveLeft = new OptionBoolean(this, "player.sleeve.left", true);
-	public @NotNull OptionBoolean playerSleeveRight = new OptionBoolean(this, "player.sleeve.right", true);
-	public @NotNull OptionBoolean playerPantLeft = new OptionBoolean(this, "player.pant.left", true);
-	public @NotNull OptionBoolean playerPantRight = new OptionBoolean(this, "player.pant.right", true);
-	public @NotNull OptionBoolean playerDevModel = new OptionBoolean(this, "player.devmodel", true);
-	public @NotNull OptionEnum<Player.PlayerConfig.HurtSound> playerHurtSound = new OptionEnum<>(this, "player.hurtsound", Player.PlayerConfig.HurtSound.class, Player.PlayerConfig.HurtSound.MASCULINE);
-
-	public @NotNull KeyBinding keyAttack = new KeyBinding("key.attack").setDefault(InputDevice.mouse, 0);
-	public @NotNull KeyBinding keyInteract = new KeyBinding("key.interact").setDefault(InputDevice.mouse, 1);
-	public @NotNull KeyBinding keyPickBlock = new KeyBinding("key.pickBlock").setDefault(InputDevice.mouse, 2);
-	public @NotNull KeyBinding keySortInventory = new KeyBinding("key.sortInventory").setDefault(InputDevice.mouse, 2);
-	public @NotNull KeyBinding keyForward = new KeyBinding("key.forward").setDefault(InputDevice.keyboard, KEY_W);
-	public @NotNull KeyBinding keyLeft = new KeyBinding("key.left").setDefault(InputDevice.keyboard, KEY_A);
-	public @NotNull KeyBinding keyBack = new KeyBinding("key.back").setDefault(InputDevice.keyboard, KEY_S);
-	public @NotNull KeyBinding keyRight = new KeyBinding("key.right").setDefault(InputDevice.keyboard, KEY_D);
-	public @NotNull KeyBinding keyJump = new KeyBinding("key.jump").setDefault(InputDevice.keyboard, KEY_SPACE);
-	public @NotNull KeyBinding keyInventory = new KeyBinding("key.inventory").setDefault(InputDevice.keyboard, KEY_E);
-	public @NotNull KeyBinding keyDrop = new KeyBinding("key.drop").setDefault(InputDevice.keyboard, KEY_Q);
-	public @NotNull KeyBinding keyChat = new KeyBinding("key.chat").setDefault(InputDevice.keyboard, KEY_T);
-	public @NotNull KeyBinding keyCommand = new KeyBinding("key.command").setDefault(InputDevice.keyboard, KEY_SLASH);
-	public @NotNull KeyBinding keyToggleFog = new KeyBinding("key.fog");
-	public @NotNull KeyBinding keyToggleGamma = new KeyBinding("key.gamma");
-	public @NotNull KeyBinding keySneak = new KeyBinding("key.sneak").setDefault(InputDevice.keyboard, KEY_LSHIFT);
-	public @NotNull KeyBinding keyFly = new KeyBinding("key.fly").setDefault(InputDevice.keyboard, KEY_LCONTROL);
-	public @NotNull KeyBinding keyGuidebook = new KeyBinding("key.guidebook").setDefault(InputDevice.keyboard, KEY_R);
-	public @NotNull KeyBinding keyDescription = new KeyBinding("key.description").setDefault(InputDevice.keyboard, KEY_LCONTROL);
-	public @NotNull KeyBinding keyShowRecipe = new KeyBinding("key.showRecipe").setDefault(InputDevice.keyboard, KEY_R);
-	public @NotNull KeyBinding keyShowUsage = new KeyBinding("key.showUsage").setDefault(InputDevice.keyboard, KEY_U);
-	public @NotNull KeyBinding keyHotBarLeft = new KeyBinding("key.hotbar.left").setDefault(InputDevice.keyboard, KEY_COMMA);
-	public @NotNull KeyBinding keyHotBarRight = new KeyBinding("key.hotbar.right").setDefault(InputDevice.keyboard, KEY_PERIOD);
-	public @NotNull KeyBinding keyHotBarSwitch = new KeyBinding("key.hotbar.switch").setDefault(InputDevice.keyboard, KEY_TAB);
-
-	public @NotNull KeyBinding keyHideGui = new KeyBinding("key.immersiveMode").setDefault(InputDevice.keyboard, KEY_F1);
-	public @NotNull KeyBinding keyScreenshot = new KeyBinding("key.screenshot").setDefault(InputDevice.keyboard, KEY_F2);
-	public @NotNull KeyBinding keyToggleDebug = new KeyBinding("key.toggleDebug").setDefault(InputDevice.keyboard, KEY_F3);
-	public @NotNull KeyBinding keyToggleOverlay = new KeyBinding("key.toggleOverlay").setDefault(InputDevice.keyboard, KEY_F4);
-	public @NotNull KeyBinding keySwitchPerspective = new KeyBinding("key.switchPerspective").setDefault(InputDevice.keyboard, KEY_F5);
-	public @NotNull KeyBinding keyCinematicCamera = new KeyBinding("key.cinematicCamera").setDefault(InputDevice.keyboard, KEY_F8);
-	public @NotNull KeyBinding keyFullScreen = new KeyBinding("key.fullscreen").setDefault(InputDevice.keyboard, KEY_F11);
-	public @NotNull KeyBinding keyReleaseCursor = new KeyBinding("key.debug.releasecursor").setDefault(InputDevice.keyboard, KEY_F12);
-
-	public @NotNull KeyBinding keyHotBarSlot1 = new KeyBinding("key.hotbar.1").setDefault(InputDevice.keyboard, KEY_1);
-	public @NotNull KeyBinding keyHotBarSlot2 = new KeyBinding("key.hotbar.2").setDefault(InputDevice.keyboard, KEY_2);
-	public @NotNull KeyBinding keyHotBarSlot3 = new KeyBinding("key.hotbar.3").setDefault(InputDevice.keyboard, KEY_3);
-	public @NotNull KeyBinding keyHotBarSlot4 = new KeyBinding("key.hotbar.4").setDefault(InputDevice.keyboard, KEY_4);
-	public @NotNull KeyBinding keyHotBarSlot5 = new KeyBinding("key.hotbar.5").setDefault(InputDevice.keyboard, KEY_5);
-	public @NotNull KeyBinding keyHotBarSlot6 = new KeyBinding("key.hotbar.6").setDefault(InputDevice.keyboard, KEY_6);
-	public @NotNull KeyBinding keyHotBarSlot7 = new KeyBinding("key.hotbar.7").setDefault(InputDevice.keyboard, KEY_7);
-	public @NotNull KeyBinding keyHotBarSlot8 = new KeyBinding("key.hotbar.8").setDefault(InputDevice.keyboard, KEY_8);
-	public @NotNull KeyBinding keyHotBarSlot9 = new KeyBinding("key.hotbar.9").setDefault(InputDevice.keyboard, KEY_9);
-
-	public @NotNull KeyBinding keyLookLeft = new KeyBinding("key.look.left").setDefault(InputDevice.keyboard, KEY_LEFT);
-	public @NotNull KeyBinding keyLookRight = new KeyBinding("key.look.right").setDefault(InputDevice.keyboard, KEY_RIGHT);
-	public @NotNull KeyBinding keyLookUp = new KeyBinding("key.look.up").setDefault(InputDevice.keyboard, KEY_UP);
-	public @NotNull KeyBinding keyLookDown = new KeyBinding("key.look.down").setDefault(InputDevice.keyboard, KEY_DOWN);
-	public @NotNull KeyBinding keyCenterView = new KeyBinding("key.look.center").setDefault(InputDevice.keyboard, KEY_END);
-	public @NotNull KeyBinding keyZoom = new KeyBinding("key.zoom").setDefault(InputDevice.keyboard, KEY_C);
-	public @NotNull KeyBinding keyPlayerList = new KeyBinding("key.playerList").setDefault(InputDevice.keyboard, KEY_L);
-	public @NotNull KeyBinding keyPhotoMode = new KeyBinding("key.photoMode").setDefault(InputDevice.keyboard, KEY_P);
-	public @NotNull KeyBinding keyLockRotation = new KeyBinding("key.lockRotation").setDefault(InputDevice.keyboard, KEY_Z);
-	public @NotNull KeyBinding keyAutoWalk = new KeyBinding("key.autoWalk");
-	public @NotNull KeyBinding keyEasyBridge = new KeyBinding("key.easyBridge");
-	public @NotNull KeyBinding keySprint = new KeyBinding("key.sprint");
-	public @NotNull KeyBinding keyOpenAchievements = new KeyBinding("key.openAchievements");
-	public @NotNull KeyBinding keyOpenStatistics = new KeyBinding("key.openStatistics");
-	public @NotNull KeyBinding keyShowConsole = new KeyBinding("key.showConsole").setDefault(InputDevice.keyboard, KEY_GRAVE);
-	public @NotNull List<KeyBinding> debugsKeys = new ArrayList<>();
-	public @NotNull KeyBinding keyReload = new KeyBinding("key.debug.reload").setDefault(InputDevice.keyboard, KEY_R);
-	public @NotNull KeyBinding keySwitchGamemode = new KeyBinding("key.debug.gamemode").setDefault(InputDevice.keyboard, KEY_N);
-	public @NotNull KeyBinding keyDumpTextures = new KeyBinding("key.debug.dumptextures").setDefault(InputDevice.keyboard, KEY_D);
-	public @NotNull KeyBinding keyFullbright = new KeyBinding("key.debug.fullbright").setDefault(InputDevice.keyboard, KEY_F);
-	public @NotNull KeyBinding keyLightmaps = new KeyBinding("key.debug.lightmap").setDefault(InputDevice.keyboard, KEY_L);
-	public @NotNull KeyBinding keyCollisionBoxes = new KeyBinding("key.debug.collision").setDefault(InputDevice.keyboard, KEY_B);
-	public @NotNull KeyBinding keyChunkBorders = new KeyBinding("key.debug.chunkborders").setDefault(InputDevice.keyboard, KEY_G);
-	public @NotNull KeyBinding keyClearChat = new KeyBinding("key.debug.clearchat").setDefault(InputDevice.keyboard, KEY_C);
-	public @NotNull KeyBinding keyPauseLostFocus = new KeyBinding("key.debug.pauseFocus").setDefault(InputDevice.keyboard, KEY_P);
-	public @NotNull KeyBinding keyToggleItemInfo = new KeyBinding("key.debug.iteminfo").setDefault(InputDevice.keyboard, KEY_H);
-	public @NotNull KeyBinding keyReloadChunks = new KeyBinding("key.debug.reloadchunks").setDefault(InputDevice.keyboard, KEY_A);
-	public @NotNull KeyBinding keySmoothLighting = new KeyBinding("key.debug.smoothlighting").setDefault(InputDevice.keyboard, KEY_S);
-	public @NotNull KeyBinding keyShowShortcuts = new KeyBinding("key.debug.shortcuts").setDefault(InputDevice.keyboard, KEY_Q);
-	public @NotNull KeyBinding keyToggleTextureAtlas = new KeyBinding("key.debug.textureAtlas");
-	public @NotNull KeyBinding keyLoadChunksQuickly = new KeyBinding("key.debug.loadChunksQuickly");
-
-	public static final @NotNull List<@NotNull KeyBinding> keys = new ArrayList<>();
-	public static final @NotNull List<@NotNull Option<?>> options = new ArrayList<>();
-	public @NotNull List<@NotNull Option<?>> getAllOptions(){
-		return options;
-	}
-	
-	public KeyBinding getKey(int i) {
-		return keys.get(i);
-	}
-
-	public String getKeyBindName(int id) {
-		return I18n.getInstance().translateKey(getKey(id).getId());
-	}
-	
-	public GameSettings(Minecraft minecraft, File file) {
-		mc = minecraft;
-		optionsFile = new File(file, "options.txt");
-
-		debugsKeys.add(keyShowShortcuts);
-		debugsKeys.add(keyReload);
-		debugsKeys.add(keySwitchGamemode);
-		debugsKeys.add(keyDumpTextures);
-		debugsKeys.add(keyFullbright);
-		debugsKeys.add(keyLightmaps);
-		debugsKeys.add(keyCollisionBoxes);
-		debugsKeys.add(keyChunkBorders);
-		debugsKeys.add(keyClearChat);
-		debugsKeys.add(keyPauseLostFocus);
-		debugsKeys.add(keyToggleItemInfo);
-		debugsKeys.add(keyReloadChunks);
-		debugsKeys.add(keySmoothLighting);
-	}
-
-	public void init() {
-		loadOptions();
-		saveOptions();
-	}
-
-	public @NotNull String getDisplayString(Option<?> option) {
-		if (option == null) return "";
-		I18n trans = I18n.getInstance();
-		if (option instanceof OptionFloat) {
-			OptionFloat optionFloat = (OptionFloat) option;
-			float value = optionFloat.value;
-			if (option == brightness) {
-				int percent = (int)(value * 200.0f);
-				if (percent == 0) {
-					return trans.translateKey("options.brightness.min");
-				}else if (percent == 100) {
-					return trans.translateKey("options.brightness.default");
-				}else if (percent == 200) {
-					return trans.translateKey("options.brightness.max");
-				}else {
-					return percent + "%";
-				}
-			}
-			if (option == mouseSensitivity) {
-				if (value == 0.0F) {
-					return trans.translateKey("options.mouseSensitivity.min");
-				}
-				if (value == 1.0F) {
-					return trans.translateKey("options.mouseSensitivity.max");
-				} else {
-					return (int) (value * 200F) + "%";
-				}
-			}
-			if (option == FoV) {
-				if (value == 0) {
-					return trans.translateKey("options.fov.min");
-				}
-				if (value == 1) {
-					return trans.translateKey("options.fov.max");
-				} else {
-					return (int) (value * 100 + 30) + "°";
-				}
-			}
-			if (option == screenPadding) {
-				int percent = (int) (value * 100);
-				return percent + "%";
-			}
-			if (option == gamma) {
-				int percent = (int) (value * 200);
-				return percent + "%";
-			}
-			if (option == autosaveTimer) {
-				int timer = (int) (value * 24);
-				if (timer == 0) {
-					return trans.translateKey("options.autosaveTimer.off");
-				} else {
-					return (timer * 5) + " seconds";
-				}
-			}
-			if (option == cloudHeight) {
-				int percent = (int)(value * 100.0f + 100.0f);
-				if (percent == 100) {
-					return trans.translateKey("options.cloudHeight.default");
-				} else {
-					return percent + "%";
-				}
-			}
-			if (option == entityRenderDistance) {
-				int percent = MathHelper.round(value * 100.0f);
-				if (percent == 100) {
-					return trans.translateKey("options.entityRenderDistance.default");
-				} else {
-					return percent + "%";
-				}
-			}
-			if (value == 0.0F) {
-				return trans.translateKey("options.off");
-			} else {
-				return (int) (value * 100F) + "%";
-			}
-		}
-		if (option == guiScale) {
-			if (guiScale.value == 0) {
-				return trans.translateKey("options.guiScale.auto");
-			} else {
-				return guiScale.value + "x";
-			}
-		}
-		if(option == customFpsLimit){
-			int value = customFpsLimit.value;
-			int maxValue = 300;
-			if (enableVsync.value){
-				return String.valueOf(mc.gameWindow.getFrequency());
-			}
-			if(value > maxValue){
-				customFpsLimit.set(maxValue);
-			}
-			if(value < 15){
-				customFpsLimit.set(0);
-				return trans.translateKey("options.customFpsLimit.unlimited");
-			}
-		}
-		if (option == animations) {
-			return trans.translateKey(ANIMATIONS[animations.value]);
-		}
-		if (option == fancyGraphics) {
-			if (fancyGraphics.value == 1) {
-				return trans.translateKey("options.graphics.fancy");
-			} else {
-				return trans.translateKey("options.graphics.fast");
-			}
-		}
-		if (option == lightmapStyle) {
-			return trans.translateKey(lightmapStyle.value.getTranslationKey());
-		}
-		if(option == bloom) {
-			if(bloom.value == 0) {
-				return trans.translateKey("options.off");
-			}else if(bloom.value == 1) {
-				return trans.translateKey("options.bloom.low");
-			}else if(bloom.value == 2) {
-				return trans.translateKey("options.bloom.high");
-			}
-		}
-		if (option == this.tooltipStyle) {
-			TooltipElement.Style style = TooltipElement.styleMap.get(this.tooltipStyle.value);
-			if (style != null) {
-				return trans.translateKey(style.translationKey);
-			}
-			return "Unknown";
-		}
-		if (option == this.font) {
-			return trans.translateKey("options.font." + this.font.value.getKey());
-		}
-		if (option instanceof OptionBoolean) {
-			Boolean flag = (Boolean) option.value;
-			if (flag) {
-				return trans.translateKey("options.on");
-			} else {
-				return trans.translateKey("options.off");
-			}
-		}
-		if(option instanceof OptionEnum<?>) {
-			OptionEnum<?> optionEnum = (OptionEnum<?>) option;
-			
-			String key;
-			
-			if(optionEnum.value instanceof ITranslatable) {
-				ITranslatable translatable = (ITranslatable) optionEnum.value;
-				
-				key = translatable.getTranslationKey();
-			}else {
-				key = optionEnum.value.toString().toLowerCase();
-			}
-			
-			return trans.translateKey("options." + optionEnum.name+"." + key);
-		}
-		return emptyStringIfNull(option.value.toString());
-	}
-
-	public void optionChanged(Option<?> option) {
-		if (option == null) return;
-		if (option == difficulty) {
-			if (mc.currentWorld != null) {
-				mc.currentWorld.setDifficulty(difficulty.value, false);
-			}
-		}
-		if(option == renderDistance) {
-			if (mc.currentScreen instanceof ScreenOptions) {
-				ScreenOptions.queueReload = true;
-			} else {
-				mc.renderGlobal.allChanged();
-			}
-		}
-
-		if(option == playerLeftHanded && mc.thePlayer != null) {mc.thePlayer.playerConfig.setLeftHand(playerLeftHanded.value);}
-		if(option == playerCape && mc.thePlayer != null) {mc.thePlayer.playerConfig.setCape(playerCape.value);}
-		if(option == playerHat && mc.thePlayer != null) {mc.thePlayer.playerConfig.setHat(playerHat.value);}
-		if(option == playerJacket && mc.thePlayer != null) {mc.thePlayer.playerConfig.setJacket(playerJacket.value);}
-		if(option == playerSleeveLeft && mc.thePlayer != null) {mc.thePlayer.playerConfig.setSleeveLeft(playerSleeveLeft.value);}
-		if(option == playerSleeveRight && mc.thePlayer != null) {mc.thePlayer.playerConfig.setSleeveRight(playerSleeveRight.value);}
-		if(option == playerPantLeft && mc.thePlayer != null) {mc.thePlayer.playerConfig.setPantLeft(playerPantLeft.value);}
-		if(option == playerPantRight && mc.thePlayer != null) {mc.thePlayer.playerConfig.setPantRight(playerPantRight.value);}
-		if(option == playerDevModel && mc.thePlayer != null) {mc.thePlayer.playerConfig.setDevModelEnabled(playerDevModel.value);}
-		if(option == playerHurtSound && mc.thePlayer != null) {mc.thePlayer.playerConfig.setHurtSound(playerHurtSound.value);}
-
-		if(option == enableVsync) mc.gameWindow.setVsync(enableVsync.value);
-		if(option == fancyGraphics) mc.renderGlobal.allChanged();
-		if(option == ambientOcclusion) mc.renderGlobal.allChanged();
-		if(option == connectedGlass) mc.renderGlobal.allChanged();
-//		if(option == advancedOpenGL) mc.renderGlobal.allChanged();
-		if(option == biomeWater) {
-			mc.renderGlobal.allChanged();
-			mc.textureManager.updateDynamicTextures(false);
-		}
-		if(option == treeShadows) mc.renderGlobal.allChanged();
-		if(option == placementMode && mc.thePlayer != null) mc.thePlayer.syncPlacementMode();
-		if(option == animations || option == customAnimations) {
-			mc.textureManager.refreshTexturesAndDisplayErrors();
-			mc.textureManager.updateDynamicTextures(false);
-			mc.renderGlobal.allChanged();
-		}
-		if(option == fullscreen) mc.gameWindow.updateWindowState();
-		if(option == borderlessFullscreen && fullscreen.value) mc.gameWindow.updateWindowState();
-		if(option == guiScale) {
-			int max = mc.resolution.getMaxScale(mc.gameWindow.getWidthScreenCoords(), mc.gameWindow.getHeightScreenCoords());
-			guiScale.value = (guiScale.value + max) % max;
-			mc.resolution.setScale(guiScale.value);
-			if (mc.currentScreen != null) {
-				mc.currentScreen.opened(mc.resolution.getScaledWidthScreenCoords(), mc.resolution.getScaledHeightScreenCoords());
-			}
-		}
-		if(option == mipmapType || option == mipmapLevels) {
-			mc.textureManager.refreshTexturesAndDisplayErrors();
-		}
-		if(option == autosaveTimer) {
-			int max = 24;
-			autosaveTimer.value = (autosaveTimer.value + max) % max;
-		}
-		if(option == discordRichPresence)
-		{
-			if (discordRichPresence.value && mc.rpcThread == null)
-			{
-				mc.rpcThread = new RichPresenceHandlerThread(mc);
-				mc.rpcThread.setName("Discord RPC Thread");
-				mc.rpcThread.start();
-			}
-		}
-		if(option == language) {
-			if (mc.currentScreen != null) {
-				mc.currentScreen.opened(mc.resolution.getScaledWidthScreenCoords(), mc.resolution.getScaledHeightScreenCoords());
-			}
-		}
-		if(option == customLightmap) {
-			mc.worldRenderer.lightmapHelper.setup();
-		}
-		if(option == rawMouseInput) {
-			mc.mouseInput.setRawInput(rawMouseInput.value);
-		}
-		if(option == enableHolidayTextures) {
-			mc.textureManager.refreshTexturesAndDisplayErrors();
-			mc.renderGlobal.allChanged();
-		}
-		if(option == musicFrequency) {
-			mc.sndManager.resetMusicTicks();
-		}
-	}
-
-	public void loadOptions() {
-		HudComponents.DEFAULT_LAYOUT = HudComponents.INSTANCE.toSettingsString();
-		if (!optionsFile.exists()) return;
-		try {
-			BufferedReader br = new BufferedReader(new FileReader(optionsFile));
-			
-line:		for (String line; (line = br.readLine()) != null;) {
-				try {
-					int i = line.indexOf(':');
-					String key = line.substring(0, i);
-					String value = line.substring(i + 1);
-					
-					if (key.equals("hudLayout")) {
-						HudComponents.INSTANCE.fromSettingsString(value);
-						continue line;
-					}
-					
-					for(Option<?> option : getAllOptions()) {
-						if(option.name.equalsIgnoreCase(key)) {
-							option.parse(value);
-							continue line;
-						}
-					}
-
-                    for (KeyBinding keyBinding : keys) {
-                        if (key.equals("key_" + keyBinding.getId())) {
-                            keyBinding.fromOptionsString(value);
-                            continue line;
-                        }
-                    }
-				} catch (Exception e) {
-                    LOGGER.warn("Skipping bad option: {}", line, e);
-				}
-			}
-
-			br.close();
-		} catch (Exception e) {
-			LOGGER.error("Failed to load options", e);
-		}
-	}
-	
-	public void saveOptions() {
-		try {
-			PrintWriter printwriter = new PrintWriter(new FileWriter(optionsFile));
-			
-			for(Option<?> option : getAllOptions()) {
-				printwriter.println(option.name+":"+option.getValueString());
-			}
-			
-			for (KeyBinding key : keys) {
-				printwriter.println("key_" + key.getId() + ":" + key.toOptionsString());
-			}
-
-			String hudComponentsString = HudComponents.INSTANCE.toSettingsString();
-			if(hudComponentsString != null) {
-				printwriter.println("hudLayout:" + hudComponentsString);
-			}
-
-			printwriter.close();
-		} catch (Exception exception) {
-			LOGGER.error("Failed to save options", exception);
-		}
-	}
+import java.io.BufferedReader;
+import java.io.File;
+import java.io.FileReader;
+import java.io.FileWriter;
+import java.io.PrintWriter;
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.List;
+import java.util.Map;
+
+import static org.lwjgl.input.Keyboard.KEY_1;
+import static org.lwjgl.input.Keyboard.KEY_2;
+import static org.lwjgl.input.Keyboard.KEY_3;
+import static org.lwjgl.input.Keyboard.KEY_4;
+import static org.lwjgl.input.Keyboard.KEY_5;
+import static org.lwjgl.input.Keyboard.KEY_6;
+import static org.lwjgl.input.Keyboard.KEY_7;
+import static org.lwjgl.input.Keyboard.KEY_8;
+import static org.lwjgl.input.Keyboard.KEY_9;
+import static org.lwjgl.input.Keyboard.KEY_A;
+import static org.lwjgl.input.Keyboard.KEY_B;
+import static org.lwjgl.input.Keyboard.KEY_C;
+import static org.lwjgl.input.Keyboard.KEY_COMMA;
+import static org.lwjgl.input.Keyboard.KEY_D;
+import static org.lwjgl.input.Keyboard.KEY_DOWN;
+import static org.lwjgl.input.Keyboard.KEY_E;
+import static org.lwjgl.input.Keyboard.KEY_END;
+import static org.lwjgl.input.Keyboard.KEY_F;
+import static org.lwjgl.input.Keyboard.KEY_F1;
+import static org.lwjgl.input.Keyboard.KEY_F11;
+import static org.lwjgl.input.Keyboard.KEY_F12;
+import static org.lwjgl.input.Keyboard.KEY_F2;
+import static org.lwjgl.input.Keyboard.KEY_F3;
+import static org.lwjgl.input.Keyboard.KEY_F4;
+import static org.lwjgl.input.Keyboard.KEY_F5;
+import static org.lwjgl.input.Keyboard.KEY_F8;
+import static org.lwjgl.input.Keyboard.KEY_G;
+import static org.lwjgl.input.Keyboard.KEY_GRAVE;
+import static org.lwjgl.input.Keyboard.KEY_H;
+import static org.lwjgl.input.Keyboard.KEY_L;
+import static org.lwjgl.input.Keyboard.KEY_LCONTROL;
+import static org.lwjgl.input.Keyboard.KEY_LSHIFT;
+import static org.lwjgl.input.Keyboard.KEY_N;
+import static org.lwjgl.input.Keyboard.KEY_P;
+import static org.lwjgl.input.Keyboard.KEY_PERIOD;
+import static org.lwjgl.input.Keyboard.KEY_Q;
+import static org.lwjgl.input.Keyboard.KEY_R;
+import static org.lwjgl.input.Keyboard.KEY_S;
+import static org.lwjgl.input.Keyboard.KEY_SLASH;
+import static org.lwjgl.input.Keyboard.KEY_SPACE;
+import static org.lwjgl.input.Keyboard.KEY_T;
+import static org.lwjgl.input.Keyboard.KEY_TAB;
+import static org.lwjgl.input.Keyboard.KEY_U;
+import static org.lwjgl.input.Keyboard.KEY_UP;
+import static org.lwjgl.input.Keyboard.KEY_W;
+import static org.lwjgl.input.Keyboard.KEY_Z;
+
+public final class GameSettings {
+    private static final @NotNull Logger LOGGER = LogUtils.getLogger();
+
+    private static final @NotNull Map<@NotNull String, @NotNull String> savedValues = new Object2ObjectOpenHashMap<>();
+
+    private static final @NotNull Map<@NotNull String, @NotNull Option<?>> registeredOptions = new Object2ObjectOpenHashMap<>();
+    private static final @NotNull Map<@NotNull String, @NotNull KeyBinding> registeredKeys = new Object2ObjectOpenHashMap<>();
+    private static final @NotNull List<@NotNull Option<?>> allOptions = new ObjectArrayList<>();
+    private static final @NotNull List<@NotNull KeyBinding> allKeys = new ObjectArrayList<>();
+
+    public static @NotNull Collection<@NotNull Option<?>> getAllOptions() {
+        return allOptions;
+    }
+
+    public static @Nullable Option<?> getOption(@NotNull String id) {
+        return registeredOptions.get(id);
+    }
+
+    public static @NotNull Collection<@NotNull KeyBinding> getAllKeys() {
+        return allKeys;
+    }
+
+    public static @Nullable KeyBinding getKeyBinding(@NotNull String id) {
+        return registeredKeys.get(id);
+    }
+
+    public static final @NotNull OptionInteger WINDOW_WIDTH = register(new OptionInteger("windowWidth", 854));
+    public static final @NotNull OptionInteger WINDOW_HEIGHT = register(new OptionInteger("windowHeight", 480));
+
+    public static final @NotNull OptionVolume MASTER_VOLUME = register(new OptionVolume("sound.master", 1.0f, SoundCategory.GUI_SOUNDS));
+    public static final @NotNull OptionVolume MUSIC_VOLUME = register(new OptionVolume("sound.music", 1.0f, SoundCategory.MUSIC));
+    public static final @NotNull OptionVolume WORLD_SOUNDS_VOLUME = register(new OptionVolume("sound.world", 1.0f, SoundCategory.WORLD_SOUNDS));
+    public static final @NotNull OptionVolume ENTITY_SOUNDS_VOLUME = register(new OptionVolume("sound.entity", 1.0f, SoundCategory.ENTITY_SOUNDS));
+    public static final @NotNull OptionVolume CAVE_SOUNDS_VOLUME = register(new OptionVolume("sound.cave", 1.0f, SoundCategory.CAVE_SOUNDS));
+    public static final @NotNull OptionVolume GUI_SOUNDS_VOLUME = register(new OptionVolume("sound.gui", 1.0f, SoundCategory.GUI_SOUNDS));
+    public static final @NotNull OptionVolume WEATHER_SOUNDS_VOLUME = register(new OptionVolume("sound.weather", 1.0f, SoundCategory.WEATHER_SOUNDS));
+    public static final @NotNull OptionBoolean PLAY_TITLE_SCREEN_MUSIC = register(new OptionBoolean("playTitleScreenMusic", false));
+
+    public static final @NotNull OptionFloat FOV = register(new OptionFloat("fov", 0.40140846f)
+        .withDisplayStringProvider((mc, i18n, option) -> {
+            if (option.value == 0) {
+                return i18n.translateKey("options.fov.min");
+            }
+            if (option.value == 1) {
+                return i18n.translateKey("options.fov.max");
+            } else {
+                return (int) (option.value * 100 + 30) + "°";
+            }
+        }));
+    public static final @NotNull OptionFloat MOUSE_SENSITIVITY = register(new OptionFloat("mouseSensitivity", 0.5f)
+        .withDisplayStringProvider((mc, i18n, option) -> {
+            if (option.value == 0.0F) {
+                return i18n.translateKey("options.mouseSensitivity.min");
+            }
+            if (option.value == 1.0F) {
+                return i18n.translateKey("options.mouseSensitivity.max");
+            } else {
+                return (int) (option.value * 200F) + "%";
+            }
+        }));
+    public static final @NotNull OptionFloat SCREEN_PADDING = register(new OptionFloat("screenPadding", 0.0f)
+        .withDisplayStringProvider((mc, i18n, option) -> {
+            int percent = (int) (option.value * 100);
+            return percent + "%";
+        }));
+    public static final @NotNull OptionFloat GAMMA = register(new OptionFloat("gamma", 0.5f)
+        .withDisplayStringProvider((mc, i18n, option) -> {
+            int percent = (int) (option.value * 200);
+            return percent + "%";
+        }));
+    public static final @NotNull OptionFloat BRIGHTNESS = register(new OptionFloat("brightness", 0.5f)
+        .withDisplayStringProvider((mc, i18n, option) -> {
+            int percent = (int) (option.value * 200.0f);
+            if (percent == 0) {
+                return i18n.translateKey("options.brightness.min");
+            } else if (percent == 100) {
+                return i18n.translateKey("options.brightness.default");
+            } else if (percent == 200) {
+                return i18n.translateKey("options.brightness.max");
+            } else {
+                return percent + "%";
+            }
+        }));
+
+    public static final @NotNull OptionFloat FXAA = register(new OptionFloat("fxaa", 0.0f));
+    public static final @NotNull OptionFloat CONTROLLER_SENSITIVITY = register(new OptionFloat("controllerSensitivity", 0.5f));
+    public static final @NotNull OptionFloat CONTROLLER_MENU_SENSITIVITY = register(new OptionFloat("controllerMenuSensitivity", 0.5f));
+    public static final @NotNull OptionFloat CONTROLLER_DEADZONE_LEFT = register(new OptionFloat("controllerDeadzoneL", 0.25f));
+    public static final @NotNull OptionFloat CONTROLLER_DEADZONE_RIGHT = register(new OptionFloat("controllerDeadzoneR", 0.25f));
+    public static final @NotNull OptionFloat BLOCK_OUTLINE_WIDTH = register(new OptionFloat("blockOutlineWidth", 0.25f));
+
+    public static final @NotNull OptionFloat FLIGHT_SPEED = register(new OptionFloat("flightSpeed", 0.5f));
+    public static final @NotNull OptionFloat FLIGHT_SMOOTHNESS = register(new OptionFloat("flightSmoothness", 0.5f));
+
+    public static final @NotNull OptionBoolean INVERT_MOUSE = register(new OptionBoolean("invertYMouse", false));
+    public static final @NotNull OptionBoolean RAW_MOUSE_INPUT = register(new OptionBoolean("rawMouseInput", false)
+        .addOnChangeCallback((mc, option) -> mc.mouseInput.setRawInput(option.value)));
+    public static final @NotNull OptionBoolean VIEW_BOBBING = register(new OptionBoolean("bobView", true));
+    public static final @NotNull OptionBoolean TRANSPARENCY_DEPTH_CHECK = register(new OptionBoolean("transparencyDepthCheck", true));
+    public static final @NotNull OptionEnum<ParticlesQuality> PARTICLES_QUALITY = register(new OptionEnum<>("particleQuality", ParticlesQuality.class, ParticlesQuality.ALL));
+    public static final @NotNull OptionRange PARTICLES_CAP = register(new OptionRange("particleCap", 4000, 500, 15000));
+    public static final @NotNull OptionFloat PARTICLE_RENDER_DISTANCE = register(new OptionFloat("particleRenderDistance", 1f)
+        .withDisplayStringProvider((mc, i18n, option) -> {
+            int percent = MathHelper.round(option.value * 100.0f);
+            if (percent == 100) {
+                return i18n.translateKey("options.particleRenderDistance.default");
+            } else {
+                return percent + "%";
+            }
+        }));
+    public static final @NotNull OptionRange CHUNK_REBUILDS_PER_FRAME = register(new OptionRange("chunkRebuilds", 6, 2, 12));
+    public static final @NotNull OptionBoolean FRUSTUM_CULLING = register(new OptionBoolean("frustumCulling", true));
+    public static final @NotNull OptionBoolean ENTITY_SHADOWS = register(new OptionBoolean("entityShadows", true));
+    public static final @NotNull OptionEnum<TextOutlineQuality> TEXT_OUTLINE_QUALITY = register(new OptionEnum<>("textOutlineQuality", TextOutlineQuality.class, TextOutlineQuality.FANCY));
+    public static final @NotNull OptionEnum<CloudQuality> CLOUD_QUALITY = register(new OptionEnum<>("cloudQuality", CloudQuality.class, CloudQuality.FANCY));
+    public static final @NotNull OptionEnum<LeavesQuality> LEAVES_QUALITY = register(new OptionEnum<>("leavesQuality", LeavesQuality.class, LeavesQuality.FANCY)
+        .addOnChangeCallback((mc, option) -> mc.renderGlobal.allChanged()));
+    public static final @NotNull OptionBoolean TREE_SHADOWS = register(new OptionBoolean("treeShadows", true)
+        .addOnChangeCallback((mc, option) -> mc.renderGlobal.allChanged()));
+    public static final @NotNull OptionBoolean CONNECTED_GLASS = register(new OptionBoolean("connectedGlass", false)
+        .addOnChangeCallback((mc, option) -> mc.renderGlobal.allChanged()));
+    public static final @NotNull OptionBoolean AMBIENT_OCCLUSION = register(new OptionBoolean("ambientOcclusion", true)
+        .addOnChangeCallback((mc, option) -> mc.renderGlobal.allChanged()));
+    public static final @NotNull OptionBoolean ITEMS_3D = register(new OptionBoolean("3Ditems", false));
+    public static final @NotNull OptionBoolean SMOOTH_CAMERA = register(new OptionBoolean("smoothCamera", false));
+    public static final @NotNull OptionBoolean LOCK_CAMERA = register(new OptionBoolean("lockCamera", false));
+    public static final @NotNull OptionBoolean BIOME_WATER = register(new OptionBoolean("biomeWater", true)
+        .addOnChangeCallback((mc, option) -> {
+            mc.textureManager.updateDynamicTextures(false);
+            mc.renderGlobal.allChanged();
+        }));
+    public static final @NotNull OptionBoolean VIGNETTE = register(new OptionBoolean("vignette", true));
+    public static final @NotNull OptionBoolean SHOW_PLAYER_LIST = register(new OptionBoolean("showPlayerList", false));
+    public static final @NotNull OptionBoolean SLIME_PARTICLES = register(new OptionBoolean("slimeParticles", true));
+    public static final @NotNull OptionString SHADER_OVERRIDE = register(new OptionString("shaderOverride", ""));
+    public static final @NotNull OptionBoolean AUTO_HIT = register(new OptionBoolean("autoHit", true));
+    public static final @NotNull OptionBoolean EASY_BRIDGE = register(new OptionBoolean("easyBridge", true));
+    public static final @NotNull OptionBoolean FOOD_HEALTH_REGEN_OVERLAY = register(new OptionBoolean("foodHealthRegenOverlay", true));
+    public static final @NotNull OptionBoolean FPS_IN_OVERLAY = register(new OptionBoolean("fpsInOverlay", false));
+    public static final @NotNull OptionBoolean VERSION_IN_OVERLAY = register(new OptionBoolean("versionInOverlay", false));
+    public static final @NotNull OptionBoolean CONTROLLER_SWAP_SHOULDER_BUTTONS = register(new OptionBoolean("controllerSwapShoulderButtons", false));
+    public static final @NotNull OptionBoolean CONTROLLER_SWAP_AB = register(new OptionBoolean("controllerSwapAB", false));
+    public static final @NotNull OptionBoolean CONTROLLER_SWAP_XY = register(new OptionBoolean("controllerSwapXY", false));
+    public static final @NotNull OptionBoolean CLOUDS = register(new OptionBoolean("clouds", true));
+    public static final @NotNull OptionFloat CLOUD_HEIGHT = register(new OptionFloat("cloudHeight", 0f)
+        .withDisplayStringProvider((mc, i18n, option) -> {
+            int percent = (int) (option.value * 100.0f + 100.0f);
+            if (percent == 100) {
+                return i18n.translateKey("options.cloudHeight.default");
+            } else {
+                return percent + "%";
+            }
+        }));
+    public static final @NotNull OptionFloat ENTITY_RENDER_DISTANCE = register(new OptionFloat("entityRenderDistance", 1f)
+        .withDisplayStringProvider((mc, i18n, option) -> {
+            int percent = MathHelper.round(option.value * 100.0f);
+            if (percent == 100) {
+                return i18n.translateKey("options.entityRenderDistance.default");
+            } else {
+                return percent + "%";
+            }
+        }));
+    public static final @NotNull OptionBoolean ARMOR_DURABILITY_OVERLAY = register(new OptionBoolean("armorDurabilityOverlay", false));
+    public static final @NotNull OptionBoolean ARMOR_PROTECTION_OVERLAY = register(new OptionBoolean("armorProtectionOverlay", true));
+    public static final @NotNull OptionBoolean HELD_ITEM_COUNT_OVERLAY = register(new OptionBoolean("heldItemCountOverlay", false));
+    public static final @NotNull OptionBoolean PAUSE_ON_LOST_FOCUS = register(new OptionBoolean("pauseOnLostFocus", true));
+    public static final @NotNull OptionBoolean SHOW_DEBUG_SCREEN = register(new OptionBoolean("showDebugScreen", false));
+    public static final @NotNull OptionBoolean SHOW_FRAME_TIMES = register(new OptionBoolean("showFrameTimes", false));
+    public static final @NotNull OptionBoolean SHOW_ITEM_DEBUG_INFO = register(new OptionBoolean("showItemDebugInfo", false));
+    public static final @NotNull OptionBoolean SHOW_CHUNK_BORDERS = register(new OptionBoolean("showChunkBorders", false));
+    public static final @NotNull OptionBoolean SHOW_COLLISION_BOXES = register(new OptionBoolean("showCollisionBoxes", false));
+    public static final @NotNull OptionBoolean SWAP_CRAFTING_BUTTONS = register(new OptionBoolean("swapCraftingButtons", false));
+    public static final @NotNull OptionBoolean FORCE_ONSCREEN_KEYBOARD = register(new OptionBoolean("forceOnscreenKeyboard", false));
+    public static final @NotNull OptionEnum<PlacementMode> PLACEMENT_MODE = register(new OptionEnum<>("placementMode", PlacementMode.class, PlacementMode.DEFAULT).setIsSlider(false)
+        .addOnChangeCallback((mc, option) -> {
+            if (mc.thePlayer != null) mc.thePlayer.syncPlacementMode();
+        }));
+    public static final @NotNull OptionBoolean DISCORD_RICH_PRESENCE = register(new OptionBoolean("discordRichPresence", false)
+        .addOnChangeCallback((mc, option) -> {
+            if (option.value && mc.rpcThread == null) {
+                mc.rpcThread = new RichPresenceHandlerThread(mc);
+                mc.rpcThread.setName("Discord RPC Thread");
+                mc.rpcThread.start();
+            }
+        }));
+    public static final @NotNull OptionImmersiveMode IMMERSIVE_MODE = register(new OptionImmersiveMode());
+    public static final @NotNull OptionColor GUI_BACKGROUND_COLOR = register(new OptionColor("guiBackgroundColor", new Color().setARGB(0xc0101010)));
+    public static final @NotNull OptionEnum<Difficulty> DIFFICULTY = register(new OptionEnum<>("difficulty", Difficulty.class, Difficulty.NORMAL) // Stub for local difficulty setting
+        .addOnChangeCallback((mc, option) -> {
+            if (mc.currentWorld != null) {
+                mc.currentWorld.setDifficulty(option.value, false);
+            }
+        }));
+    public static final @NotNull OptionInteger THIRD_PERSON_VIEW = register(new OptionInteger("thirdPersonView", 0));
+    public static final @NotNull OptionRange RENDER_DISTANCE = register(new OptionRange("renderDistance", 12, 2, 32)
+        .addOnChangeCallback((mc, option) -> {
+            if (mc.currentScreen instanceof ScreenOptions) {
+                ScreenOptions.queueReload = true;
+            } else {
+                mc.renderGlobal.allChanged();
+            }
+        }));
+    public static final @NotNull OptionBoolean ENABLE_VSYNC = register(new OptionBoolean("enableVsync", false)
+        .addOnChangeCallback((mc, option) -> mc.gameWindow.setVsync(option.value)));
+    public static final @NotNull OptionEnum<ChatVisibility> chatVisibility = register(new OptionEnum<>("chatVisibility", ChatVisibility.class, ChatVisibility.SHOW_ALL));
+    public static final @NotNull OptionRange CUSTOM_FPS_LIMIT = register(new OptionRange("customFpsLimit", 165, 301)
+        .withDisplayStringProvider((mc, i18n, option) -> {
+            int value = option.value;
+            int maxValue = 300;
+            if (ENABLE_VSYNC.value) {
+                return String.valueOf(mc.gameWindow.getFrequency());
+            }
+            if (value > maxValue) {
+                option.set(maxValue);
+            }
+            if (value < 15) {
+                option.set(0);
+                return i18n.translateKey("options.customFpsLimit.unlimited");
+            }
+            return option.toOptionsString();
+        }));
+    public static final @NotNull OptionGuiScale GUI_SCALE = register(new OptionGuiScale("guiScale", 0)
+        .addOnChangeCallback((mc, option) -> {
+            int max = ScaledResolution.getMaxScale(mc.gameWindow.getWidthScreenCoords(), mc.gameWindow.getHeightScreenCoords());
+            option.value = (option.value + max) % max;
+            mc.resolution.setScale(option.value);
+            if (mc.currentScreen != null) {
+                mc.currentScreen.opened(mc.resolution.getScaledWidthScreenCoords(), mc.resolution.getScaledHeightScreenCoords());
+            }
+        })
+        .withDisplayStringProvider((mc, i18n, option) -> {
+            if (option.value == 0) {
+                return i18n.translateKey("options.guiScale.auto");
+            } else {
+                return option.value + "x";
+            }
+        }));
+    public static final @NotNull OptionInteger OVERLAY_MODE = register(new OptionInteger("overlayMode", 0));
+    public static final @NotNull OptionInteger ROTATION_OVERLAY_MODE = register(new OptionInteger("rotationOverlayMode", 0));
+    public static final @NotNull OptionEnum<TextureAnimation> TEXTURE_ANIMATIONS = register(new OptionEnum<>("animations", TextureAnimation.class, TextureAnimation.CUSTOM)
+        .addOnChangeCallback((mc, option) -> {
+            mc.textureManager.refreshTexturesAndDisplayErrors();
+            mc.textureManager.updateDynamicTextures(false);
+            mc.renderGlobal.allChanged();
+        }));
+    public static final @NotNull OptionBoolean CUSTOM_TEXTURE_ANIMATIONS = register(new OptionBoolean("customAnimations", true)
+        .addOnChangeCallback((mc, option) -> {
+            mc.textureManager.refreshTexturesAndDisplayErrors();
+            mc.textureManager.updateDynamicTextures(false);
+            mc.renderGlobal.allChanged();
+        }));
+    public static final @NotNull OptionInteger PLAYER_LIST_POSITION = register(new OptionInteger("playerListPosition", 2));
+    public static final @NotNull OptionBoolean HELD_ITEM_TOOLTIPS = register(new OptionBoolean("heldItemTooltips", true));
+    public static final @NotNull OptionFloat COLOR_CORRECTION = register(new OptionFloat("colorCorrection", 0.5f));
+    public static final @NotNull OptionBoolean SNEAK_TOGGLE = register(new OptionBoolean("sneakToggle", false));
+    public static final @NotNull OptionFloat AUTOSAVE_TIMER = register(new OptionFloat("autosaveTimer", 0.04166666666F)
+        .addOnChangeCallback((mc, option) -> {
+            int max = 24;
+            option.value = (option.value + max) % max;
+        })
+        .withDisplayStringProvider((mc, i18n, option) -> {
+            int timer = (int) (option.value * 24);
+            if (timer == 0) {
+                return i18n.translateKey("options.autosaveTimer.off");
+            } else {
+                return (timer * 5) + " seconds";
+            }
+        }));
+    public static final @NotNull OptionBoolean ENABLE_ITEM_DRAGGING = register(new OptionBoolean("enableItemDragging", true));
+    public static final @NotNull OptionRange BLOOM = register(new OptionRange("bloom", 0, 3)
+        .withDisplayStringProvider((mc, i18n, option) -> {
+            if (option.value == 0) {
+                return i18n.translateKey("options.off");
+            } else if (option.value == 1) {
+                return i18n.translateKey("options.bloom.low");
+            } else if (option.value == 2) {
+                return i18n.translateKey("options.bloom.high");
+            }
+            return option.toOptionsString();
+        }));
+    public static final @NotNull OptionEnum<RenderScale> RENDER_SCALE = register(new OptionEnum<>("renderScale", RenderScale.class, RenderScale.SCALE_100));
+    public static final @NotNull OptionBoolean HEAT_HAZE = register(new OptionBoolean("heatHaze", false));
+    public static final @NotNull OptionBoolean ALPHA_MENU = register(new OptionBoolean("old", false));
+    public static final @NotNull OptionBoolean ENABLE_ITEM_CLUMPING = register(new OptionBoolean("enableItemClumping", true));
+    public static final @NotNull OptionEnum<DescriptionPromptEnum> ITEM_DESCRIPTIONS = register(new OptionEnum<>("itemDescriptions", DescriptionPromptEnum.class, DescriptionPromptEnum.PROMPT));
+    public static final @NotNull OptionBoolean TURN_WITH_VEHICLE = register(new OptionBoolean("turnWithVehicle", true));
+    public static final @NotNull OptionBoolean DISABLE_CRASH_HANDLER = register(new OptionBoolean("disableCrashHandler", false));
+    public static final @NotNull OptionEnum<SelectedProvider> CHUNK_PROVIDER = register(new OptionEnum<>("enableThreadedChunkProvider", SelectedProvider.class, SelectedProvider.THREADED));
+    public static final @NotNull OptionBoolean MUSIC_TOASTS = register(new OptionBoolean("musicToasts", true));
+    public static final @NotNull OptionEnum<MusicFrequency> MUSIC_FREQUENCY = register(new OptionEnum<>("musicFrequency", MusicFrequency.class, MusicFrequency.DEFAULT)
+        .addOnChangeCallback((mc, option) -> mc.sndManager.resetMusicTicks()));
+
+    public static final @NotNull OptionBoolean ENABLE_DEV_RESOURCE_LOADING = register(new OptionBoolean("enableDevResourceLoading", false));
+    public static final @NotNull OptionBoolean DOWNLOAD_SOUNDFILES = register(new OptionBoolean("downloadSoundfiles", true));
+    public static final @NotNull OptionBoolean ALLOW_SOUND_OVERRIDES = register(new OptionBoolean("allowSoundOverrides", false));
+    public static final @NotNull OptionBoolean LOAD_ALL_SOUNDS = register(new OptionBoolean("loadAllSounds", false));
+
+    public static final @NotNull OptionBoolean OVERLAY_SHOW_COORDS = register(new OptionBoolean("overlayShowCoords", true));
+    public static final @NotNull OptionBoolean OVERLAY_SHOW_DIRECTION = register(new OptionBoolean("overlayShowDirection", true));
+    public static final @NotNull OptionBoolean OVERLAY_SHOW_TIME = register(new OptionBoolean("overlayShowTime", true));
+    public static final @NotNull OptionBoolean OVERLAY_SHOW_SEASON = register(new OptionBoolean("overlayShowSeason", true));
+    public static final @NotNull OptionBoolean OVERLAY_SHOW_WEATHER = register(new OptionBoolean("overlayShowWeather", true));
+    public static final @NotNull OptionBoolean OVERLAY_SHOW_BIOME = register(new OptionBoolean("overlayShowBiome", true));
+
+    public static final @NotNull OptionBoolean @NotNull [] OVERLAY_ELEMENTS = new OptionBoolean[]{OVERLAY_SHOW_COORDS, OVERLAY_SHOW_DIRECTION, OVERLAY_SHOW_TIME, OVERLAY_SHOW_SEASON, OVERLAY_SHOW_WEATHER, OVERLAY_SHOW_BIOME};
+
+    public static final @NotNull OptionString LAST_SERVER = register(new OptionString("lastServer", ""));
+    public static final @NotNull OptionString SKIN = register(new OptionString("skin", "Default"));
+    public static final @NotNull OptionString SELECTED_CONTROLLER = register(new OptionString("selectedController", ""));
+    public static final @NotNull OptionString LANGUAGE = register(new OptionString("language", "en_US")
+        .addOnChangeCallback((mc, option) -> {
+            if (mc.currentScreen != null) {
+                mc.currentScreen.opened(mc.resolution.getScaledWidthScreenCoords(), mc.resolution.getScaledHeightScreenCoords());
+            }
+        }));
+
+    public static final @NotNull OptionRange MIPMAP_LEVELS = register(new OptionRange("mipmapLevels", 0, 5)
+        .addOnChangeCallback((mc, option) -> mc.textureManager.refreshTexturesAndDisplayErrors()));
+    public static final @NotNull OptionEnum<MipmapType> MIPMAP_TYPE = register(new OptionEnum<>("mipmapType", MipmapType.class, MipmapType.SMOOTH)
+        .addOnChangeCallback((mc, option) -> mc.textureManager.refreshTexturesAndDisplayErrors()));
+
+    public static final @NotNull OptionBoolean FOV_MODIFICATION = register(new OptionBoolean("fov.modification", true));
+    public static final @NotNull OptionBoolean SCREEN_MOTION_EFFECTS = register(new OptionBoolean("screen.motion.effects", true));
+
+    public static final @NotNull OptionBoolean FULLSCREEN = register(new OptionBoolean("fullscreen", Minecraft.isClientASteamDeck())
+        .addOnChangeCallback((mc, option) -> mc.gameWindow.updateWindowState()));
+    public static final @NotNull OptionBoolean BORDERLESS_FULLSCREEN = register(new OptionBoolean("borderlessFullscreen", true)
+        .addOnChangeCallback((mc, option) -> {
+            if (FULLSCREEN.value) mc.gameWindow.updateWindowState();
+        }));
+    public static final @NotNull OptionBoolean START_IN_FULLSCREEN = register(new OptionBoolean("startInFullscreen", true));
+    public static final @NotNull OptionTooltip TOOLTIP_STYLE = register(new OptionTooltip("tooltipStyle", "default")
+        .withDisplayStringProvider((mc, i18n, option) -> {
+            TooltipElement.Style style = TooltipElement.styleMap.get(option.value);
+            if (style != null) {
+                return i18n.translateKey(style.translationKey);
+            }
+            return "Unknown";
+        }));
+    public static final @NotNull OptionFont FONT = register(new OptionFont("font", Fonts.DEFAULT)
+        .withDisplayStringProvider((mc, i18n, option) -> i18n.translateKey("options.font." + option.value.getKey())));
+    public static final @NotNull OptionEnum<LightmapStyle> LIGHTMAP_STYLE = register(new OptionEnum<>("lightmapStyle", LightmapStyle.class, LightmapStyle.GRAY)
+        .withDisplayStringProvider((mc, i18n, option) -> i18n.translateKey(option.value.getTranslationKey())));
+    public static final @NotNull OptionBoolean CUSTOM_LIGHTMAP = register(new OptionBoolean("customLightmap", true)
+        .addOnChangeCallback((mc, option) -> mc.worldRenderer.lightmapHelper.setup()));
+    public static final @NotNull OptionBoolean FOG = register(new OptionBoolean("fog", true));
+    public static final @NotNull OptionBoolean HIDE_UNDISCOVERED_ITEMS = register(new OptionBoolean("hideUndiscoveredItems", true));
+    public static final @NotNull OptionBoolean MUTE_ON_LOST_FOCUS = register(new OptionBoolean("muteOnLostFocus", false));
+    public static final @NotNull OptionBoolean AURORA = register(new OptionBoolean("aurora", true));
+    public static final @NotNull OptionBoolean MOB_VARIANTS = register(new OptionBoolean("mobVariants", true));
+    public static final @NotNull OptionEnum<Colorblindness> COLORBLINDNESS_FIX = register(new OptionEnum<>("colorblindnessFix", Colorblindness.class, Colorblindness.NONE));
+    public static final @NotNull OptionBoolean SUBTITLES = register(new OptionBoolean("subtitles", false));
+    public static final @NotNull OptionBoolean DEVELOPER_MODE = register(new OptionBoolean("developerMode", false));
+    public static final @NotNull OptionBoolean VIEW_SUPPORT_MODE = register(new OptionBoolean("viewSupportMode", false));
+    public static final @NotNull OptionBoolean ENABLE_HOLIDAY_TEXTURES = register(new OptionBoolean("enableHolidayTextures", true)
+        .addOnChangeCallback((mc, option) -> {
+            mc.textureManager.refreshTexturesAndDisplayErrors();
+            mc.renderGlobal.allChanged();
+        }));
+    public static final @NotNull OptionBoolean DYNAMIC_CURSOR = register(new OptionBoolean("dynamicCursor", true));
+    public static final @NotNull OptionBoolean DEV_MODELS = register(new OptionBoolean("devModels", true));
+    public static final @NotNull OptionBoolean DO_JCE_CHECK = register(new OptionBoolean("doJCECheck", true));
+    public static final @NotNull OptionString UUID_SERVER = register(new OptionString("uuidServer", "https://api.minecraftservices.com/minecraft/profile/lookup/name/%s"));
+
+    public static final @NotNull OptionBoolean PLAYER_LEFT_HANDED = register(new OptionBoolean("player.left.handed", false)
+        .addOnChangeCallback((mc, option) -> {
+            if (mc.thePlayer != null) {
+                mc.thePlayer.playerConfig.setLeftHand(option.value);
+            }
+        }));
+    public static final @NotNull OptionBoolean PLAYER_CAPE = register(new OptionBoolean("player.cape", true)
+        .addOnChangeCallback((mc, option) -> {
+            if (mc.thePlayer != null) {
+                mc.thePlayer.playerConfig.setCape(option.value);
+            }
+        }));
+    public static final @NotNull OptionBoolean PLAYER_HAT = register(new OptionBoolean("player.hat", true)
+        .addOnChangeCallback((mc, option) -> {
+            if (mc.thePlayer != null) {
+                mc.thePlayer.playerConfig.setHat(option.value);
+            }
+        }));
+    public static final @NotNull OptionBoolean PLAYER_JACKET = register(new OptionBoolean("player.jacket", true)
+        .addOnChangeCallback((mc, option) -> {
+            if (mc.thePlayer != null) {
+                mc.thePlayer.playerConfig.setJacket(option.value);
+            }
+        }));
+    public static final @NotNull OptionBoolean PLAYER_SLEEVE_LEFT = register(new OptionBoolean("player.sleeve.left", true)
+        .addOnChangeCallback((mc, option) -> {
+            if (mc.thePlayer != null) {
+                mc.thePlayer.playerConfig.setSleeveLeft(option.value);
+            }
+        }));
+    public static final @NotNull OptionBoolean PLAYER_SLEEVE_RIGHT = register(new OptionBoolean("player.sleeve.right", true)
+        .addOnChangeCallback((mc, option) -> {
+            if (mc.thePlayer != null) {
+                mc.thePlayer.playerConfig.setSleeveRight(option.value);
+            }
+        }));
+    public static final @NotNull OptionBoolean PLAYER_PANT_LEFT = register(new OptionBoolean("player.pant.left", true)
+        .addOnChangeCallback((mc, option) -> {
+            if (mc.thePlayer != null) {
+                mc.thePlayer.playerConfig.setPantLeft(option.value);
+            }
+        }));
+    public static final @NotNull OptionBoolean PLAYER_PANT_RIGHT = register(new OptionBoolean("player.pant.right", true)
+        .addOnChangeCallback((mc, option) -> {
+            if (mc.thePlayer != null) {
+                mc.thePlayer.playerConfig.setPantRight(option.value);
+            }
+        }));
+    public static final @NotNull OptionBoolean PLAYER_DEV_MODEL = register(new OptionBoolean("player.devmodel", true)
+        .addOnChangeCallback((mc, option) -> {
+            if (mc.thePlayer != null) {
+                mc.thePlayer.playerConfig.setDevModelEnabled(option.value);
+            }
+        }));
+    public static final @NotNull OptionEnum<Player.PlayerConfig.HurtSound> PLAYER_HURT_SOUND = register(new OptionEnum<>("player.hurtsound", Player.PlayerConfig.HurtSound.class, Player.PlayerConfig.HurtSound.MASCULINE)
+        .addOnChangeCallback((mc, option) -> {
+            if (mc.thePlayer != null) {
+                mc.thePlayer.playerConfig.setHurtSound(option.value);
+            }
+        }));
+
+    public static final @NotNull KeyBinding KEY_ATTACK = register(new KeyBinding("key.attack").setDefault(InputDevice.mouse, 0));
+    public static final @NotNull KeyBinding KEY_INTERACT = register(new KeyBinding("key.interact").setDefault(InputDevice.mouse, 1));
+    public static final @NotNull KeyBinding KEY_PICK_BLOCK = register(new KeyBinding("key.pickBlock").setDefault(InputDevice.mouse, 2));
+    public static final @NotNull KeyBinding KEY_SORT_INVENTORY = register(new KeyBinding("key.sortInventory").setDefault(InputDevice.mouse, 2));
+    public static final @NotNull KeyBinding KEY_FORWARD = register(new KeyBinding("key.forward").setDefault(InputDevice.keyboard, KEY_W));
+    public static final @NotNull KeyBinding KEY_LEFT = register(new KeyBinding("key.left").setDefault(InputDevice.keyboard, KEY_A));
+    public static final @NotNull KeyBinding KEY_BACK = register(new KeyBinding("key.back").setDefault(InputDevice.keyboard, KEY_S));
+    public static final @NotNull KeyBinding KEY_RIGHT = register(new KeyBinding("key.right").setDefault(InputDevice.keyboard, KEY_D));
+    public static final @NotNull KeyBinding KEY_JUMP = register(new KeyBinding("key.jump").setDefault(InputDevice.keyboard, KEY_SPACE));
+    public static final @NotNull KeyBinding KEY_INVENTORY = register(new KeyBinding("key.inventory").setDefault(InputDevice.keyboard, KEY_E));
+    public static final @NotNull KeyBinding KEY_DROP = register(new KeyBinding("key.drop").setDefault(InputDevice.keyboard, KEY_Q));
+    public static final @NotNull KeyBinding KEY_CHAT = register(new KeyBinding("key.chat").setDefault(InputDevice.keyboard, KEY_T));
+    public static final @NotNull KeyBinding KEY_COMMAND = register(new KeyBinding("key.command").setDefault(InputDevice.keyboard, KEY_SLASH));
+    public static final @NotNull KeyBinding KEY_TOGGLE_FOG = register(new KeyBinding("key.fog"));
+    public static final @NotNull KeyBinding KEY_TOGGLE_GAMMA = register(new KeyBinding("key.gamma"));
+    public static final @NotNull KeyBinding KEY_SNEAK = register(new KeyBinding("key.sneak").setDefault(InputDevice.keyboard, KEY_LSHIFT));
+    public static final @NotNull KeyBinding KEY_FLY = register(new KeyBinding("key.fly").setDefault(InputDevice.keyboard, KEY_LCONTROL));
+    public static final @NotNull KeyBinding KEY_GUIDEBOOK = register(new KeyBinding("key.guidebook").setDefault(InputDevice.keyboard, KEY_R));
+    public static final @NotNull KeyBinding KEY_DESCRIPTION = register(new KeyBinding("key.description").setDefault(InputDevice.keyboard, KEY_LCONTROL));
+    public static final @NotNull KeyBinding KEY_SHOW_RECIPE = register(new KeyBinding("key.showRecipe").setDefault(InputDevice.keyboard, KEY_R));
+    public static final @NotNull KeyBinding KEY_SHOW_USAGE = register(new KeyBinding("key.showUsage").setDefault(InputDevice.keyboard, KEY_U));
+    public static final @NotNull KeyBinding KEY_HOT_BAR_LEFT = register(new KeyBinding("key.hotbar.left").setDefault(InputDevice.keyboard, KEY_COMMA));
+    public static final @NotNull KeyBinding KEY_HOT_BAR_RIGHT = register(new KeyBinding("key.hotbar.right").setDefault(InputDevice.keyboard, KEY_PERIOD));
+    public static final @NotNull KeyBinding KEY_HOT_BAR_SWITCH = register(new KeyBinding("key.hotbar.switch").setDefault(InputDevice.keyboard, KEY_TAB));
+
+    public static final @NotNull KeyBinding KEY_HIDE_GUI = register(new KeyBinding("key.immersiveMode").setDefault(InputDevice.keyboard, KEY_F1));
+    public static final @NotNull KeyBinding KEY_SCREENSHOT = register(new KeyBinding("key.screenshot").setDefault(InputDevice.keyboard, KEY_F2));
+    public static final @NotNull KeyBinding KEY_TOGGLE_DEBUG = register(new KeyBinding("key.toggleDebug").setDefault(InputDevice.keyboard, KEY_F3));
+    public static final @NotNull KeyBinding KEY_TOGGLE_OVERLAY = register(new KeyBinding("key.toggleOverlay").setDefault(InputDevice.keyboard, KEY_F4));
+    public static final @NotNull KeyBinding KEY_SWITCH_PERSPECTIVE = register(new KeyBinding("key.switchPerspective").setDefault(InputDevice.keyboard, KEY_F5));
+    public static final @NotNull KeyBinding KEY_CINEMATIC_CAMERA = register(new KeyBinding("key.cinematicCamera").setDefault(InputDevice.keyboard, KEY_F8));
+    public static final @NotNull KeyBinding KEY_FULL_SCREEN = register(new KeyBinding("key.fullscreen").setDefault(InputDevice.keyboard, KEY_F11));
+    public static final @NotNull KeyBinding KEY_RELEASE_CURSOR = register(new KeyBinding("key.debug.releasecursor").setDefault(InputDevice.keyboard, KEY_F12));
+
+    public static final @NotNull KeyBinding KEY_HOT_BAR_SLOT_1 = register(new KeyBinding("key.hotbar.1").setDefault(InputDevice.keyboard, KEY_1));
+    public static final @NotNull KeyBinding KEY_HOT_BAR_SLOT_2 = register(new KeyBinding("key.hotbar.2").setDefault(InputDevice.keyboard, KEY_2));
+    public static final @NotNull KeyBinding KEY_HOT_BAR_SLOT_3 = register(new KeyBinding("key.hotbar.3").setDefault(InputDevice.keyboard, KEY_3));
+    public static final @NotNull KeyBinding KEY_HOT_BAR_SLOT_4 = register(new KeyBinding("key.hotbar.4").setDefault(InputDevice.keyboard, KEY_4));
+    public static final @NotNull KeyBinding KEY_HOT_BAR_SLOT_5 = register(new KeyBinding("key.hotbar.5").setDefault(InputDevice.keyboard, KEY_5));
+    public static final @NotNull KeyBinding KEY_HOT_BAR_SLOT_6 = register(new KeyBinding("key.hotbar.6").setDefault(InputDevice.keyboard, KEY_6));
+    public static final @NotNull KeyBinding KEY_HOT_BAR_SLOT_7 = register(new KeyBinding("key.hotbar.7").setDefault(InputDevice.keyboard, KEY_7));
+    public static final @NotNull KeyBinding KEY_HOT_BAR_SLOT_8 = register(new KeyBinding("key.hotbar.8").setDefault(InputDevice.keyboard, KEY_8));
+    public static final @NotNull KeyBinding KEY_HOT_BAR_SLOT_9 = register(new KeyBinding("key.hotbar.9").setDefault(InputDevice.keyboard, KEY_9));
+
+    public static final @NotNull KeyBinding KEY_LOOK_LEFT = register(new KeyBinding("key.look.left").setDefault(InputDevice.keyboard, Keyboard.KEY_LEFT));
+    public static final @NotNull KeyBinding KEY_LOOK_RIGHT = register(new KeyBinding("key.look.right").setDefault(InputDevice.keyboard, Keyboard.KEY_RIGHT));
+    public static final @NotNull KeyBinding KEY_LOOK_UP = register(new KeyBinding("key.look.up").setDefault(InputDevice.keyboard, KEY_UP));
+    public static final @NotNull KeyBinding KEY_LOOK_DOWN = register(new KeyBinding("key.look.down").setDefault(InputDevice.keyboard, KEY_DOWN));
+    public static final @NotNull KeyBinding KEY_CENTER_VIEW = register(new KeyBinding("key.look.center").setDefault(InputDevice.keyboard, KEY_END));
+    public static final @NotNull KeyBinding KEY_ZOOM = register(new KeyBinding("key.zoom").setDefault(InputDevice.keyboard, KEY_C));
+    public static final @NotNull KeyBinding KEY_PLAYER_LIST = register(new KeyBinding("key.playerList").setDefault(InputDevice.keyboard, KEY_L));
+    public static final @NotNull KeyBinding KEY_PHOTO_MODE = register(new KeyBinding("key.photoMode").setDefault(InputDevice.keyboard, KEY_P));
+    public static final @NotNull KeyBinding KEY_LOCK_ROTATION = register(new KeyBinding("key.lockRotation").setDefault(InputDevice.keyboard, KEY_Z));
+    public static final @NotNull KeyBinding KEY_AUTO_WALK = register(new KeyBinding("key.autoWalk"));
+    public static final @NotNull KeyBinding KEY_EASY_BRIDGE = register(new KeyBinding("key.easyBridge"));
+    public static final @NotNull KeyBinding KEY_SPRINT = register(new KeyBinding("key.sprint"));
+    public static final @NotNull KeyBinding KEY_OPEN_ACHIEVEMENTS = register(new KeyBinding("key.openAchievements"));
+    public static final @NotNull KeyBinding KEY_OPEN_STATISTICS = register(new KeyBinding("key.openStatistics"));
+    public static final @NotNull KeyBinding KEY_SHOW_CONSOLE = register(new KeyBinding("key.showConsole").setDefault(InputDevice.keyboard, KEY_GRAVE));
+
+    public static final @NotNull List<KeyBinding> DEBUG_KEYS = new ArrayList<>();
+    public static final @NotNull KeyBinding KEY_RELOAD = register(new KeyBinding("key.debug.reload").setDefault(InputDevice.keyboard, KEY_R));
+    public static final @NotNull KeyBinding KEY_SWITCH_GAMEMODE = register(new KeyBinding("key.debug.gamemode").setDefault(InputDevice.keyboard, KEY_N));
+    public static final @NotNull KeyBinding KEY_DUMP_TEXTURES = register(new KeyBinding("key.debug.dumptextures").setDefault(InputDevice.keyboard, KEY_D));
+    public static final @NotNull KeyBinding KEY_FULLBRIGHT = register(new KeyBinding("key.debug.fullbright").setDefault(InputDevice.keyboard, KEY_F));
+    public static final @NotNull KeyBinding KEY_LIGHTMAPS = register(new KeyBinding("key.debug.lightmap").setDefault(InputDevice.keyboard, KEY_L));
+    public static final @NotNull KeyBinding KEY_COLLISION_BOXES = register(new KeyBinding("key.debug.collision").setDefault(InputDevice.keyboard, KEY_B));
+    public static final @NotNull KeyBinding KEY_CHUNK_BORDERS = register(new KeyBinding("key.debug.chunkborders").setDefault(InputDevice.keyboard, KEY_G));
+    public static final @NotNull KeyBinding KEY_CLEAR_CHAT = register(new KeyBinding("key.debug.clearchat").setDefault(InputDevice.keyboard, KEY_C));
+    public static final @NotNull KeyBinding KEY_PAUSE_LOST_FOCUS = register(new KeyBinding("key.debug.pauseFocus").setDefault(InputDevice.keyboard, KEY_P));
+    public static final @NotNull KeyBinding KEY_TOGGLE_ITEM_INFO = register(new KeyBinding("key.debug.iteminfo").setDefault(InputDevice.keyboard, KEY_H));
+    public static final @NotNull KeyBinding KEY_RELOAD_CHUNKS = register(new KeyBinding("key.debug.reloadchunks").setDefault(InputDevice.keyboard, KEY_A));
+    public static final @NotNull KeyBinding KEY_SMOOTH_LIGHTING = register(new KeyBinding("key.debug.smoothlighting").setDefault(InputDevice.keyboard, KEY_S));
+    public static final @NotNull KeyBinding KEY_SHOW_SHORTCUTS = register(new KeyBinding("key.debug.shortcuts").setDefault(InputDevice.keyboard, KEY_Q));
+    public static final @NotNull KeyBinding KEY_TOGGLE_TEXTURE_ATLAS = register(new KeyBinding("key.debug.textureAtlas"));
+    public static final @NotNull KeyBinding KEY_LOAD_CHUNKS_QUICKLY = register(new KeyBinding("key.debug.loadChunksQuickly"));
+
+    static {
+        DEBUG_KEYS.add(KEY_SHOW_SHORTCUTS);
+        DEBUG_KEYS.add(KEY_RELOAD);
+        DEBUG_KEYS.add(KEY_SWITCH_GAMEMODE);
+        DEBUG_KEYS.add(KEY_DUMP_TEXTURES);
+        DEBUG_KEYS.add(KEY_FULLBRIGHT);
+        DEBUG_KEYS.add(KEY_LIGHTMAPS);
+        DEBUG_KEYS.add(KEY_COLLISION_BOXES);
+        DEBUG_KEYS.add(KEY_CHUNK_BORDERS);
+        DEBUG_KEYS.add(KEY_CLEAR_CHAT);
+        DEBUG_KEYS.add(KEY_PAUSE_LOST_FOCUS);
+        DEBUG_KEYS.add(KEY_TOGGLE_ITEM_INFO);
+        DEBUG_KEYS.add(KEY_RELOAD_CHUNKS);
+        DEBUG_KEYS.add(KEY_SMOOTH_LIGHTING);
+    }
+
+    private static File optionsFile;
+
+    public static @NotNull <T extends Option<E>, E> T register(@NotNull T option) {
+        if (registeredOptions.containsKey(option.id))
+            throw new IllegalArgumentException("Option with name '" + option.id + "' is already registered!");
+        registeredOptions.put(option.id, option);
+        allOptions.add(option);
+        if (savedValues.containsKey(option.id)) {
+            option.fromOptionsString(savedValues.get(option.id));
+        }
+        return option;
+    }
+
+    public static @NotNull KeyBinding register(@NotNull KeyBinding keyBinding) {
+        if (registeredKeys.containsKey(keyBinding.getId()))
+            throw new IllegalArgumentException("Keybinding with name '" + keyBinding.getId() + "' is already registered!");
+        registeredKeys.put(keyBinding.getId(), keyBinding);
+        allKeys.add(keyBinding);
+        if (savedValues.containsKey("key_" + keyBinding.getId())) {
+            keyBinding.fromOptionsString(savedValues.get("key_" + keyBinding.getId()));
+        }
+        return keyBinding;
+    }
+
+    public static void init(@NotNull File mcDirectory) {
+        GameSettings.optionsFile = new File(mcDirectory, "options.txt");
+        HudComponents.DEFAULT_LAYOUT = HudComponents.INSTANCE.toSettingsString();
+
+        loadOptions();
+        saveOptions();
+    }
+
+    public static void loadOptions() {
+        if (optionsFile == null || !optionsFile.exists()) return;
+        try {
+            BufferedReader br = new BufferedReader(new FileReader(optionsFile));
+            br.lines().forEach(line -> {
+                    int i = line.indexOf(':');
+                    String key = line.substring(0, i);
+                    String value = line.substring(i + 1);
+                    savedValues.put(key, value);
+                }
+            );
+            br.close();
+        } catch (Exception e) {
+            LOGGER.error("Failed to load options", e);
+        }
+
+        try {
+            for (var entry : savedValues.entrySet()) {
+                String key = entry.getKey();
+                String value = entry.getValue();
+
+                if (key.equals("hudLayout")) {
+                    HudComponents.INSTANCE.fromSettingsString(value);
+                    continue;
+                }
+
+                Option<?> option = getOption(key);
+                if (option != null) {
+                    option.fromOptionsString(value);
+                    continue;
+                }
+
+                KeyBinding keyBinding = getKeyBinding(key.replaceFirst("key_", ""));
+                if (keyBinding != null) {
+                    keyBinding.fromOptionsString(value);
+                }
+            }
+        } catch (Exception e) {
+            LOGGER.error("Failed to load options", e);
+        }
+    }
+
+    public static void saveOptions() {
+        for (var option : allOptions) {
+            savedValues.put(option.id, option.toOptionsString());
+        }
+        for (var keyBind : allKeys) {
+            savedValues.put("key_" + keyBind.getId(), keyBind.toOptionsString());
+        }
+        savedValues.put("hudLayout", HudComponents.INSTANCE.toSettingsString());
+        try {
+            PrintWriter printwriter = new PrintWriter(new FileWriter(optionsFile));
+
+            List<String> keys = new ArrayList<>(savedValues.keySet());
+            keys.sort(String::compareTo);
+            for (var key : keys) {
+                printwriter.print(key);
+                printwriter.print(":");
+                printwriter.println(savedValues.get(key));
+            }
+
+            printwriter.close();
+        } catch (Exception exception) {
+            LOGGER.error("Failed to save options", exception);
+        }
+    }
 
 }
